
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny25
;Clock frequency        : 8.000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny25
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x11
	.EQU GPIOR1=0x12
	.EQU GPIOR2=0x13

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Next_Faze=R3
	.DEF _TWI_Read_count=R2
	.DEF _TWI_Write_count=R5
	.DEF _TWI_Start_count=R4
	.DEF _TWI_Stop_count=R7

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _usi_start_isr
	RJMP _usi_ovf_isr

;GPIOR0-GPIOR2 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00
	.EQU  __GPIOR1_INIT=0x00
	.EQU  __GPIOR2_INIT=0x00

_0x3D:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x02
	.DW  _0x3D*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : AVR I2C Slave
;Version :
;Date    : 21/05/2010
;Author  : Scorpio
;Company :
;Comments:      USI   TWI Slave  .
;
;
;Chip type           : ATtiny25
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;External RAM size   : 0
;Data Stack size     : 32
;*****************************************************/
;
;#include <tiny25.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;
;#define LED_ON PORTB.3=0    //  ,    2.
;#define LED_OFF PORTB.3=1
;#define LED_TEST_ON 1
;
;#define INT_OVF_ON  USICR |=0x40
;#define INT_OVF_OFF USICR &=0xBF
;#define INT_STR_ON  USICR |=0x80
;#define INT_STR_OFF USICR &=0x7F
;
;#define SCL_ST      PINB.2
;#define SCL_IN      DDRB &=0xFB  //SCL  .
;#define SCL_OUT     DDRB |=0x04  //SCL  .
;//#define SCL_LOW     PORTB.2=0
;#define SDA_IN      DDRB &=0xFE  //SDA  .
;#define SDA_OUT     DDRB |=0x01  //SDA  .
;#define SDA_LOW     PORTB.0=0
;#define SDA_HIGH    PORTB.0=1
;
;
;#define TWI_ADR 0xA0
;#define TWI_Data   		USIDR
;#define TWI_Status  	USISR
;#define TWI_Control 	USICR
;#define TWI_buffer_size 16
;
;#define TWI_Stop_Cond  	USISR & 0x20
;#define TWI_Stop_Reset  USISR |=0x20
;#define TWI_Err_Cond  	USISR & 0x10
;
;unsigned char Next_Faze = 0;                   //   
;unsigned char TWI_Read_buffer[TWI_buffer_size];  //   
;unsigned char TWI_Read_count=0;                  //  
;unsigned char TWI_Write_buffer[TWI_buffer_size]; //   
;unsigned char TWI_Write_count=0;                 //  
;unsigned char TWI_Write_temp[TWI_buffer_size]; //   
;
;unsigned char TWI_Start_count=0;                 //   ()
;unsigned char TWI_Stop_count=0;                  // STOP  ()
;
;bit New_Data_Flag=0;
;
;eeprom char Datos_Read[TWI_buffer_size]; //   ()
;eeprom char Debug_Info[8];               //   ()
;eeprom char Addr_Info[8];               //   ()
;unsigned char Dev_Addr_Info[8];         //   ()
;
;void blink(int nblink) //   
; 0000 004A {

	.CSEG
_blink:
; 0000 004B  int i;
; 0000 004C  for(i=0;i<nblink;i++)
	RCALL __SAVELOCR2
;	nblink -> Y+2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x4:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x5
; 0000 004D  {
; 0000 004E   LED_ON;
	CBI  0x18,3
; 0000 004F   delay_ms(500);
	RCALL SUBOPT_0x0
; 0000 0050   LED_OFF;
	SBI  0x18,3
; 0000 0051   delay_ms(500);
	RCALL SUBOPT_0x0
; 0000 0052   }
	__ADDWRN 16,17,1
	RJMP _0x4
_0x5:
; 0000 0053 }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;
;// USI     (SCL=1, SDA=1->0)
;interrupt [USI_STRT] void usi_start_isr(void)
; 0000 0057 {
_usi_start_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0058  TWI_Status=0xF0; //   (  ),  .
	RCALL SUBOPT_0x1
; 0000 0059  SCL_IN;          //SCL     .
	ANDI R30,LOW(0xFB)
	ANDI R31,HIGH(0xFB)
	RCALL SUBOPT_0x2
; 0000 005A  INT_OVF_ON;      //    
	ORI  R30,0x40
	OUT  0xD,R30
; 0000 005B  Next_Faze = 0;
	CLR  R3
; 0000 005C  //TWI_Read_count=0;
; 0000 005D  //TWI_Write_count=0;
; 0000 005E  TWI_Start_count++; //()
	INC  R4
; 0000 005F }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;// USI         (SCL=0, SDA  )
;interrupt [USI_OVF] void usi_ovf_isr(void)
; 0000 0063 {
_usi_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0064  unsigned char DIV_ADR;
; 0000 0065  while(SCL_ST);    //   SCL
	ST   -Y,R17
;	DIV_ADR -> R17
_0xA:
	SBIC 0x16,2
	RJMP _0xA
; 0000 0066 // TWI_Status = 0xFF;
; 0000 0067 
; 0000 0068 switch(Next_Faze)
	MOV  R30,R3
	RCALL SUBOPT_0x3
; 0000 0069         {
; 0000 006A 
; 0000 006B         case 0:{ //    
	SBIW R30,0
	BRNE _0x10
; 0000 006C                 Dev_Addr_Info[TWI_Start_count]=TWI_Data;  //()
	MOV  R26,R4
	SUBI R26,-LOW(_Dev_Addr_Info)
	RCALL SUBOPT_0x4
; 0000 006D                 DIV_ADR=TWI_Data & 0xFE;
	IN   R30,0xF
	RCALL SUBOPT_0x5
	MOV  R17,R30
; 0000 006E                 if (DIV_ADR!= TWI_ADR) INT_OVF_OFF; //    
	CPI  R17,160
	BREQ _0x11
	IN   R30,0xD
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x6
; 0000 006F                 else //
	RJMP _0x12
_0x11:
; 0000 0070                  {
; 0000 0071                  Next_Faze = ((TWI_Data & 0x01) + 1); //   ,      (1/2)
	IN   R30,0xF
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0x1)
	SUBI R30,-LOW(1)
	MOV  R3,R30
; 0000 0072                  TWI_Status = 0xFE;  //   ,         (ACK)
	RCALL SUBOPT_0x7
; 0000 0073                  TWI_Data = 0x00; //   ,
; 0000 0074                  SDA_OUT; //SDA_LOW; //    TWI_Data.0, .. SDA = 0 (ACK)
; 0000 0075                  New_Data_Flag=1; //  ()
	SBI  0x11,0
; 0000 0076                  }
_0x12:
; 0000 0077                 break;}
	RJMP _0xF
; 0000 0078 
; 0000 0079         case 1:{ //     (ACK),   
_0x10:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x15
; 0000 007A                 Next_Faze = 3;//        8- 
	LDI  R30,LOW(3)
	MOV  R3,R30
; 0000 007B                 TWI_Status = 0xF0; //  
	RCALL SUBOPT_0x1
; 0000 007C                 SDA_IN;            // SDA   
	ANDI R30,LOW(0xFE)
	ANDI R31,HIGH(0xFE)
	OUT  0x17,R30
; 0000 007D 
; 0000 007E                 break;}
	RJMP _0xF
; 0000 007F 
; 0000 0080         case 2: {//     (ACK),   
_0x15:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x16
; 0000 0081                 //    
; 0000 0082 
; 0000 0083                 Next_Faze = 4;//       
	RCALL SUBOPT_0x8
; 0000 0084                 TWI_Data = TWI_Write_buffer[TWI_Write_count]; //      8- 
; 0000 0085                 TWI_Write_temp[TWI_Write_count]= TWI_Data;
; 0000 0086                 TWI_Write_count++;
	RCALL SUBOPT_0x9
; 0000 0087 				SDA_OUT;SDA_HIGH; //  SDA    .
; 0000 0088                 TWI_Status = 0xF0; //    
; 0000 0089 				break;}
	RJMP _0xF
; 0000 008A 
; 0000 008B 		case 3:{
_0x16:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x19
; 0000 008C 				if (TWI_Read_count < TWI_buffer_size) //   
	LDI  R30,LOW(16)
	CP   R2,R30
	BRSH _0x1A
; 0000 008D 				{
; 0000 008E 				  TWI_Read_buffer[TWI_Read_count] = TWI_Data; //  
	MOV  R26,R2
	SUBI R26,-LOW(_TWI_Read_buffer)
	RCALL SUBOPT_0x4
; 0000 008F                   TWI_Read_count++;
	INC  R2
; 0000 0090 				  TWI_Status = 0xFE;  //   ,         (ACK)
	RCALL SUBOPT_0x7
; 0000 0091                   TWI_Data = 0x00; //   ,
; 0000 0092                   SDA_OUT; //SDA_LOW; //    TWI_Data.0, .. SDA = 0 (ACK)
; 0000 0093 				  Next_Faze = 1; //   
	LDI  R30,LOW(1)
	MOV  R3,R30
; 0000 0094 
; 0000 0095 
; 0000 0096 				}
; 0000 0097 				else {SDA_IN;INT_OVF_OFF;} // ,   
	RJMP _0x1B
_0x1A:
	IN   R30,0x17
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x6
_0x1B:
; 0000 0098 				break;}
	RJMP _0xF
; 0000 0099 
; 0000 009A 		case 4:{//          
_0x19:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x1C
; 0000 009B 				Next_Faze = 5; 	//   ,   
	LDI  R30,LOW(5)
	MOV  R3,R30
; 0000 009C 				SDA_IN;             // SDA  
	IN   R30,0x17
	RCALL SUBOPT_0x5
	OUT  0x17,R30
; 0000 009D 				TWI_Status = 0xFE;  //   ,         (ACK)
	LDI  R30,LOW(254)
	OUT  0xE,R30
; 0000 009E 				TWI_Data = 0xFF;    //       
	LDI  R30,LOW(255)
	OUT  0xF,R30
; 0000 009F 				break;	}
	RJMP _0xF
; 0000 00A0 
; 0000 00A1 		case 5:{
_0x1C:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xF
; 0000 00A2 				// ,    
; 0000 00A3 				if ((~TWI_Data & 0x01) && (TWI_Write_count < TWI_buffer_size))
	IN   R30,0xF
	COM  R30
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0x1)
	BREQ _0x1F
	LDI  R30,LOW(16)
	CP   R5,R30
	BRLO _0x20
_0x1F:
	RJMP _0x1E
_0x20:
; 0000 00A4 				{
; 0000 00A5 				 Next_Faze = 4; //  - 
	RCALL SUBOPT_0x8
; 0000 00A6 				 TWI_Data = TWI_Write_buffer[TWI_Write_count]; //      8- 
; 0000 00A7                  TWI_Write_temp[TWI_Write_count]= TWI_Data;
; 0000 00A8                  TWI_Write_count++;
	RCALL SUBOPT_0x9
; 0000 00A9 				 SDA_OUT;SDA_HIGH; //  SDA    .
; 0000 00AA                  TWI_Status = 0xF0; //    
; 0000 00AB 				}
; 0000 00AC 				else {SDA_IN;INT_OVF_OFF;} // ,     
	RJMP _0x23
_0x1E:
	IN   R30,0x17
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x6
_0x23:
; 0000 00AD 				break; }
; 0000 00AE 
; 0000 00AF 		}
_0xF:
; 0000 00B0 
; 0000 00B1 }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;
;// Declare your global variables here
;
;void main(void)
; 0000 00B7 {
_main:
; 0000 00B8 // Declare your local variables here
; 0000 00B9 long i;
; 0000 00BA 
; 0000 00BB // Crystal Oscillator division factor: 1
; 0000 00BC #pragma optsize-
; 0000 00BD CLKPR=0x80;
	SBIW R28,4
;	i -> Y+0
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 00BE CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 00BF #ifdef _OPTIMIZE_SIZE_
; 0000 00C0 #pragma optsize+
; 0000 00C1 #endif
; 0000 00C2 
; 0000 00C3 // Input/Output Ports initialization
; 0000 00C4 // Port B initialization
; 0000 00C5 // Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In
; 0000 00C6 // State5=T State4=T State3=0 State2=T State1=T State0=T
; 0000 00C7 PORTB=0x00;
	OUT  0x18,R30
; 0000 00C8 DDRB=0x08;
	LDI  R30,LOW(8)
	OUT  0x17,R30
; 0000 00C9 
; 0000 00CA // Timer/Counter 0 initialization
; 0000 00CB // Clock source: System Clock
; 0000 00CC // Clock value: Timer 0 Stopped
; 0000 00CD // Mode: Normal top=FFh
; 0000 00CE // OC0A output: Disconnected
; 0000 00CF // OC0B output: Disconnected
; 0000 00D0 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2A,R30
; 0000 00D1 TCCR0B=0x00;
	OUT  0x33,R30
; 0000 00D2 TCNT0=0x00;
	OUT  0x32,R30
; 0000 00D3 OCR0A=0x00;
	OUT  0x29,R30
; 0000 00D4 OCR0B=0x00;
	OUT  0x28,R30
; 0000 00D5 
; 0000 00D6 // Timer/Counter 1 initialization
; 0000 00D7 // Clock source: System Clock
; 0000 00D8 // Clock value: Timer 1 Stopped
; 0000 00D9 // Mode: Normal top=FFh
; 0000 00DA // OC1A output: Disconnected
; 0000 00DB // OC1B output: Disconnected
; 0000 00DC // Timer 1 Overflow Interrupt: Off
; 0000 00DD // Compare A Match Interrupt: Off
; 0000 00DE // Compare B Match Interrupt: Off
; 0000 00DF PLLCSR=0x00;
	OUT  0x27,R30
; 0000 00E0 TCCR1=0x00;
	OUT  0x30,R30
; 0000 00E1 GTCCR=0x00;
	OUT  0x2C,R30
; 0000 00E2 TCNT1=0x00;
	OUT  0x2F,R30
; 0000 00E3 OCR1A=0x00;
	OUT  0x2E,R30
; 0000 00E4 OCR1B=0x00;
	OUT  0x2B,R30
; 0000 00E5 OCR1C=0x00;
	OUT  0x2D,R30
; 0000 00E6 
; 0000 00E7 // External Interrupt(s) initialization
; 0000 00E8 // INT0: Off
; 0000 00E9 // Interrupt on any change on pins PCINT0-5: Off
; 0000 00EA GIMSK=0x00;
	OUT  0x3B,R30
; 0000 00EB MCUCR=0x00;
	OUT  0x35,R30
; 0000 00EC 
; 0000 00ED // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00EE TIMSK=0x00;
	OUT  0x39,R30
; 0000 00EF 
; 0000 00F0 // Universal Serial Interface initialization
; 0000 00F1 //      (Slave)
; 0000 00F2 // Mode: Two Wire (I2C), SCL low on cnt. ovf.
; 0000 00F3 // ( SCL,          )
; 0000 00F4 // Clock source: Reg.=ext. neg., Cnt.=ext. both edges
; 0000 00F5 //(      SCL,     SCL)
; 0000 00F6 // USI Counter Overflow Interrupt: On
; 0000 00F7 // USI Start Condition Interrupt: On
; 0000 00F8 TWI_Control=0xFC;
	LDI  R30,LOW(252)
	OUT  0xD,R30
; 0000 00F9 
; 0000 00FA // Analog Comparator initialization
; 0000 00FB // Analog Comparator: Off
; 0000 00FC ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00FD ADCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x3,R30
; 0000 00FE 
; 0000 00FF blink(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0xA
	RCALL _blink
; 0000 0100 for(i=0;i<16;i++) TWI_Write_buffer[i]=i+10; //   ()
	RCALL SUBOPT_0xB
_0x25:
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	BRGE _0x26
	RCALL SUBOPT_0xE
	SUBI R30,-LOW(_TWI_Write_buffer)
	MOV  R26,R30
	RCALL SUBOPT_0xE
	__ADDD1N 10
	ST   X,R30
	RCALL SUBOPT_0xF
	RJMP _0x25
_0x26:
; 0000 0102 #asm("sei")
	sei
; 0000 0103 
; 0000 0104 while (1)
_0x27:
; 0000 0105       {
; 0000 0106         while(!New_Data_Flag);
_0x2A:
	SBIS 0x11,0
	RJMP _0x2A
; 0000 0107         for(i=0;i<5000;i++)
	RCALL SUBOPT_0xB
_0x2E:
	RCALL SUBOPT_0xC
	__CPD2N 0x1388
	BRGE _0x2F
; 0000 0108         {
; 0000 0109          if(SCL_ST && (TWI_Stop_Cond)){TWI_Stop_count++;TWI_Stop_Reset;}
	SBIS 0x16,2
	RJMP _0x31
	IN   R30,0xE
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0x20)
	BRNE _0x32
_0x31:
	RJMP _0x30
_0x32:
	INC  R7
	IN   R30,0xE
	RCALL SUBOPT_0x3
	ORI  R30,0x20
	OUT  0xE,R30
; 0000 010A         }
_0x30:
	RCALL SUBOPT_0xF
	RJMP _0x2E
_0x2F:
; 0000 010B         delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0xA
	RCALL _delay_ms
; 0000 010C         for(i=0;i<16;i++){Datos_Read[i]=TWI_Read_buffer[i];TWI_Read_buffer[i]=0;} //    ...
	RCALL SUBOPT_0xB
_0x34:
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	BRGE _0x35
	RCALL SUBOPT_0xE
	SUBI R30,LOW(-_Datos_Read)
	SBCI R31,HIGH(-_Datos_Read)
	MOVW R26,R30
	RCALL SUBOPT_0xE
	SUBI R30,-LOW(_TWI_Read_buffer)
	LD   R30,Z
	RCALL __EEPROMWRB
	RCALL SUBOPT_0xE
	SUBI R30,-LOW(_TWI_Read_buffer)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RCALL SUBOPT_0xF
	RJMP _0x34
_0x35:
; 0000 010D         for(i=0;i<8;i++){Addr_Info[i]=Dev_Addr_Info[i];Dev_Addr_Info[i]=0;}       //    
	RCALL SUBOPT_0xB
_0x37:
	RCALL SUBOPT_0xC
	__CPD2N 0x8
	BRGE _0x38
	RCALL SUBOPT_0xE
	SUBI R30,LOW(-_Addr_Info)
	SBCI R31,HIGH(-_Addr_Info)
	MOVW R26,R30
	RCALL SUBOPT_0xE
	SUBI R30,-LOW(_Dev_Addr_Info)
	LD   R30,Z
	RCALL __EEPROMWRB
	RCALL SUBOPT_0xE
	SUBI R30,-LOW(_Dev_Addr_Info)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RCALL SUBOPT_0xF
	RJMP _0x37
_0x38:
; 0000 010E         Debug_Info[0]=TWI_Start_count;
	MOV  R30,R4
	LDI  R26,LOW(_Debug_Info)
	LDI  R27,HIGH(_Debug_Info)
	RCALL __EEPROMWRB
; 0000 010F         Debug_Info[1]=TWI_Read_count;
	__POINTW2MN _Debug_Info,1
	MOV  R30,R2
	RCALL __EEPROMWRB
; 0000 0110         Debug_Info[2]=TWI_Write_count;
	__POINTW2MN _Debug_Info,2
	MOV  R30,R5
	RCALL __EEPROMWRB
; 0000 0111         Debug_Info[3]=TWI_Stop_count;
	__POINTW2MN _Debug_Info,3
	MOV  R30,R7
	RCALL __EEPROMWRB
; 0000 0112 
; 0000 0113        if(LED_TEST_ON)
; 0000 0114        {
; 0000 0115         blink(TWI_Start_count);
	MOV  R30,R4
	RCALL SUBOPT_0x10
; 0000 0116         delay_ms(3000);
; 0000 0117         blink(TWI_Read_count);
	MOV  R30,R2
	RCALL SUBOPT_0x10
; 0000 0118         delay_ms(3000);
; 0000 0119         blink(TWI_Write_count);
	MOV  R30,R5
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0xA
	RCALL _blink
; 0000 011A        }
; 0000 011B         New_Data_Flag=0;
	CBI  0x11,0
; 0000 011C         TWI_Start_count=0;
	CLR  R4
; 0000 011D         TWI_Read_count=0;
	CLR  R2
; 0000 011E         TWI_Write_count=0;
	CLR  R5
; 0000 011F         TWI_Stop_count=0;
	CLR  R7
; 0000 0120        };
	RJMP _0x27
; 0000 0121 }
_0x3C:
	RJMP _0x3C

	.DSEG
_TWI_Read_buffer:
	.BYTE 0x10
_TWI_Write_buffer:
	.BYTE 0x10
_TWI_Write_temp:
	.BYTE 0x10

	.ESEG
_Datos_Read:
	.BYTE 0x10
_Debug_Info:
	.BYTE 0x8
_Addr_Info:
	.BYTE 0x8

	.DSEG
_Dev_Addr_Info:
	.BYTE 0x8

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(240)
	OUT  0xE,R30
	IN   R30,0x17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	OUT  0x17,R30
	IN   R30,0xD
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0x3:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	IN   R30,0xF
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0xFE)
	ANDI R31,HIGH(0xFE)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	ANDI R30,LOW(0xBF)
	ANDI R31,HIGH(0xBF)
	OUT  0xD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(254)
	OUT  0xE,R30
	LDI  R30,LOW(0)
	OUT  0xF,R30
	IN   R30,0x17
	RCALL SUBOPT_0x3
	ORI  R30,1
	OUT  0x17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(4)
	MOV  R3,R30
	LDI  R26,LOW(_TWI_Write_buffer)
	ADD  R26,R5
	LD   R30,X
	OUT  0xF,R30
	MOV  R26,R5
	SUBI R26,-LOW(_TWI_Write_temp)
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	INC  R5
	IN   R30,0x17
	RCALL SUBOPT_0x3
	ORI  R30,1
	OUT  0x17,R30
	SBI  0x18,0
	LDI  R30,LOW(240)
	OUT  0xE,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xB:
	__CLRD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xD:
	__CPD2N 0x10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0xE:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0xE
	__SUBD1N -1
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0xA
	RCALL _blink
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0xA
	RJMP _delay_ms


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
