/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : AVR I2C Slave
Version : 
Date    : 21/05/2010
Author  : Scorpio
Company : 
Comments:      USI   TWI Slave  .


Chip type           : ATtiny25
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 32
*****************************************************/

#include <tiny25.h>
#include <delay.h>


#define LED_ON PORTB.3=0    //  ,    2.
#define LED_OFF PORTB.3=1
#define LED_TEST_ON 1

#define INT_OVF_ON  USICR |=0x40
#define INT_OVF_OFF USICR &=0xBF
#define INT_STR_ON  USICR |=0x80
#define INT_STR_OFF USICR &=0x7F

#define SCL_ST      PINB.2
#define SCL_IN      DDRB &=0xFB  //SCL  .
#define SCL_OUT     DDRB |=0x04  //SCL  .
//#define SCL_LOW     PORTB.2=0
#define SDA_IN      DDRB &=0xFE  //SDA  .
#define SDA_OUT     DDRB |=0x01  //SDA  .
#define SDA_LOW     PORTB.0=0
#define SDA_HIGH    PORTB.0=1


#define TWI_ADR 0xA0
#define TWI_Data   		USIDR
#define TWI_Status  	USISR
#define TWI_Control 	USICR
#define TWI_buffer_size 16

#define TWI_Stop_Cond  	USISR & 0x20
#define TWI_Stop_Reset  USISR |=0x20
#define TWI_Err_Cond  	USISR & 0x10

unsigned char Next_Faze = 0;                   //   
unsigned char TWI_Read_buffer[TWI_buffer_size];  //   
unsigned char TWI_Read_count=0;                  //  
unsigned char TWI_Write_buffer[TWI_buffer_size]; //   
unsigned char TWI_Write_count=0;                 //  
unsigned char TWI_Write_temp[TWI_buffer_size]; //   

unsigned char TWI_Start_count=0;                 //   ()
unsigned char TWI_Stop_count=0;                  // STOP  ()

bit New_Data_Flag=0;

eeprom char Datos_Read[TWI_buffer_size]; //   ()
eeprom char Debug_Info[8];               //   ()
eeprom char Addr_Info[8];               //   ()
unsigned char Dev_Addr_Info[8];         //   ()

void blink(int nblink) //   
{
 int i;
 for(i=0;i<nblink;i++)
 {
  LED_ON;
  delay_ms(500);
  LED_OFF;
  delay_ms(500);
  }
}

// USI     (SCL=1, SDA=1->0)
interrupt [USI_STRT] void usi_start_isr(void)
{
 TWI_Status=0xF0; //   (  ).
 SCL_IN;          //SCL     .
 INT_OVF_ON;      //    
 Next_Faze = 0;
 //TWI_Read_count=0;
 //TWI_Write_count=0;
 TWI_Start_count++; //()
}

// USI         (SCL=0, SDA  )
interrupt [USI_OVF] void usi_ovf_isr(void)
{
 unsigned char DIV_ADR; 
 while(SCL_ST);    //   SCL
// TWI_Status = 0xFF;
  
switch(Next_Faze)
        {
            
        case 0:{ //    
                Dev_Addr_Info[TWI_Start_count]=TWI_Data;  //()
                DIV_ADR=TWI_Data & 0xFE;
                if (DIV_ADR!= TWI_ADR) INT_OVF_OFF; //    
                else //
                 {
                 Next_Faze = ((TWI_Data & 0x01) + 1); //   ,      (1/2)
                 TWI_Status = 0xFE;  //   ,         (ACK)
                 TWI_Data = 0x00; //   ,
                 SDA_OUT; //SDA_LOW; //    TWI_Data.0, .. SDA = 0 (ACK)
                 New_Data_Flag=1; //  ()
                 }
                break;}
                
        case 1:{ //     (ACK),   
                Next_Faze = 3;//        8- 
                TWI_Status = 0xF0; //   
                SDA_IN;            // SDA   
               
                break;}
                
        case 2: {//     (ACK),   
                //    
                
                Next_Faze = 4;//       
                TWI_Data = TWI_Write_buffer[TWI_Write_count]; //      8- 
                TWI_Write_temp[TWI_Write_count]= TWI_Data;
                TWI_Write_count++;
				SDA_OUT;SDA_HIGH; //  SDA    .
                TWI_Status = 0xF0; //    
				break;}
				
		case 3:{
				if (TWI_Read_count < TWI_buffer_size) //   
				{
				  TWI_Read_buffer[TWI_Read_count] = TWI_Data; //  
                  TWI_Read_count++;
				  TWI_Status = 0xFE;  //   ,         (ACK)
                  TWI_Data = 0x00; //   ,
                  SDA_OUT; //SDA_LOW; //    TWI_Data.0, .. SDA = 0 (ACK)
				  Next_Faze = 1; //   
                 
                  
				}
				else {SDA_IN;INT_OVF_OFF;} // ,   
				break;}
				
		case 4:{//          
				Next_Faze = 5; 	//   ,   
				SDA_IN;             // SDA  
				TWI_Status = 0xFE;  //   ,         (ACK)
				TWI_Data = 0xFF;    //       
				break;	}
			
		case 5:{
				// ,    
				if ((~TWI_Data & 0x01) && (TWI_Write_count < TWI_buffer_size)) 
				{
				 Next_Faze = 4; //  - 
				 TWI_Data = TWI_Write_buffer[TWI_Write_count]; //      8- 
                 TWI_Write_temp[TWI_Write_count]= TWI_Data;
                 TWI_Write_count++;
				 SDA_OUT;SDA_HIGH; //  SDA    .
                 TWI_Status = 0xF0; //    
				}
				else {SDA_IN;INT_OVF_OFF;} // ,     
				break; }
			
		}	

}


// Declare your global variables here

void main(void)
{
// Declare your local variables here
long i;

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State5=T State4=T State3=0 State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x08;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFh
// OC1A output: Disconnected
// OC1B output: Disconnected
// Timer 1 Overflow Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
PLLCSR=0x00;
TCCR1=0x00;
GTCCR=0x00;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Universal Serial Interface initialization
//      (Slave)
// Mode: Two Wire (I2C), SCL low on cnt. ovf.
// ( SCL,          )
// Clock source: Reg.=ext. neg., Cnt.=ext. both edges 
//(      SCL,     SCL)
// USI Counter Overflow Interrupt: On
// USI Start Condition Interrupt: On
TWI_Control=0xFC;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

blink(5);
for(i=0;i<16;i++) TWI_Write_buffer[i]=i+10; //   ()
// Global enable interrupts
#asm("sei")

while (1)
      {
        while(!New_Data_Flag);
        for(i=0;i<5000;i++)
        {
         if(SCL_ST && (TWI_Stop_Cond)){TWI_Stop_count++;TWI_Stop_Reset;}
        }        
        delay_ms(1000);
        for(i=0;i<16;i++){Datos_Read[i]=TWI_Read_buffer[i];TWI_Read_buffer[i]=0;} //    ...
        for(i=0;i<8;i++){Addr_Info[i]=Dev_Addr_Info[i];Dev_Addr_Info[i]=0;}       //    
        Debug_Info[0]=TWI_Start_count;                                            
        Debug_Info[1]=TWI_Read_count;
        Debug_Info[2]=TWI_Write_count;  
        Debug_Info[3]=TWI_Stop_count;
                                                                              
       if(LED_TEST_ON)
       {
        blink(TWI_Start_count);
        delay_ms(3000);
        blink(TWI_Read_count);
        delay_ms(3000);
        blink(TWI_Write_count);
       }
        New_Data_Flag=0;
        TWI_Start_count=0;
        TWI_Read_count=0;
        TWI_Write_count=0;
        TWI_Stop_count=0;
       };
}
