
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; 
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb USICR=0x0d;
sfrb USISR=0x0e;
sfrb USIDR=0x0f;
sfrb USIBR=0x10;
sfrb GPIOR0=0x11;
sfrb GPIOR1=0x12;
sfrb GPIOR2=0x13;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb PRR=0x20;
sfrb WDTCR=0x21;
sfrb DWDR=0x22;
sfrb DTPS=0x23;
sfrb DTVALB=0x24;
sfrb DTVALC=0x25;
sfrb CLKPR=0x26;
sfrb PLLCSR=0x27;
sfrb OCR0B=0x28;
sfrb OCR0A=0x29;
sfrb TCCR0A=0x2a;
sfrb OCR1B=0x2b;
sfrb GTCCR=0x2c;
sfrb OCR1C=0x2d;
sfrb OCR1A=0x2e;
sfrb TCNT1=0x2f;
sfrb TCCR1=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned char Next_Faze = 0;                   
unsigned char TWI_Read_buffer[16];  
unsigned char TWI_Read_count=0;                  
unsigned char TWI_Write_buffer[16]; 
unsigned char TWI_Write_count=0;                 
unsigned char TWI_Write_temp[16]; 

unsigned char TWI_Start_count=0;                 
unsigned char TWI_Stop_count=0;                  

bit New_Data_Flag=0;

eeprom char Datos_Read[16]; 
eeprom char Debug_Info[8];               
eeprom char Addr_Info[8];               
unsigned char Dev_Addr_Info[8];         

void blink(int nblink) 
{
int i;
for(i=0;i<nblink;i++)
{
PORTB.3=0    ;
delay_ms(500);
PORTB.3=1;
delay_ms(500);
}
}

interrupt [14] void usi_start_isr(void)
{
USISR=0xF0; 
DDRB &=0xFB  ;          
USICR |=0x40;      
Next_Faze = 0;

TWI_Start_count++; 
}

interrupt [15] void usi_ovf_isr(void)
{
unsigned char DIV_ADR; 
while(PINB.2);    

switch(Next_Faze)
{

case 0:{ 
Dev_Addr_Info[TWI_Start_count]=USIDR;  
DIV_ADR=USIDR & 0xFE;
if (DIV_ADR!= 0xA0) USICR &=0xBF; 
else 
{
Next_Faze = ((USIDR & 0x01) + 1); 
USISR = 0xFE;  
USIDR = 0x00; 
DDRB |=0x01  ; 
New_Data_Flag=1; 
}
break;}

case 1:{ 
Next_Faze = 3;
USISR = 0xF0; 
DDRB &=0xFE  ;            

break;}

case 2: {

Next_Faze = 4;
USIDR = TWI_Write_buffer[TWI_Write_count]; 
TWI_Write_temp[TWI_Write_count]= USIDR;
TWI_Write_count++;
DDRB |=0x01  ;PORTB.0=1; 
USISR = 0xF0; 
break;}

case 3:{
if (TWI_Read_count < 16) 
{
TWI_Read_buffer[TWI_Read_count] = USIDR; 
TWI_Read_count++;
USISR = 0xFE;  
USIDR = 0x00; 
DDRB |=0x01  ; 
Next_Faze = 1; 

}
else {DDRB &=0xFE  ;USICR &=0xBF;} 
break;}

case 4:{
Next_Faze = 5; 	
DDRB &=0xFE  ;             
USISR = 0xFE;  
USIDR = 0xFF;    
break;	}

case 5:{

if ((~USIDR & 0x01) && (TWI_Write_count < 16)) 
{
Next_Faze = 4; 
USIDR = TWI_Write_buffer[TWI_Write_count]; 
TWI_Write_temp[TWI_Write_count]= USIDR;
TWI_Write_count++;
DDRB |=0x01  ;PORTB.0=1; 
USISR = 0xF0; 
}
else {DDRB &=0xFE  ;USICR &=0xBF;} 
break; }

}	

}

void main(void)
{

long i;

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+

PORTB=0x00;
DDRB=0x08;

TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

PLLCSR=0x00;
TCCR1=0x00;
GTCCR=0x00;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0x00;

GIMSK=0x00;
MCUCR=0x00;

TIMSK=0x00;

USICR=0xFC;

ACSR=0x80;
ADCSRB=0x00;

blink(5);
for(i=0;i<16;i++) TWI_Write_buffer[i]=i+10; 

#asm("sei")

while (1)
{
while(!New_Data_Flag);
for(i=0;i<5000;i++)
{
if(PINB.2 && (USISR & 0x20)){TWI_Stop_count++;USISR |=0x20;}
}        
delay_ms(1000);
for(i=0;i<16;i++){Datos_Read[i]=TWI_Read_buffer[i];TWI_Read_buffer[i]=0;} 
for(i=0;i<8;i++){Addr_Info[i]=Dev_Addr_Info[i];Dev_Addr_Info[i]=0;}       
Debug_Info[0]=TWI_Start_count;                                            
Debug_Info[1]=TWI_Read_count;
Debug_Info[2]=TWI_Write_count;  
Debug_Info[3]=TWI_Stop_count;

if(1)
{
blink(TWI_Start_count);
delay_ms(3000);
blink(TWI_Read_count);
delay_ms(3000);
blink(TWI_Write_count);
}
New_Data_Flag=0;
TWI_Start_count=0;
TWI_Read_count=0;
TWI_Write_count=0;
TWI_Stop_count=0;
};
}
